// #autoload
// #name = hideweapon
// #version = 1.1
// #date = June 16, 2001
// #author = |eX|DEbig3
// #warrior =  DEbig3
// #email = debig3@qwest.net
// #web = http://scripts.tribalwar.com/debig3
// #description = hides only the weapons the user defines, after a user defined length of time
// #status = release
// #config = hideweaponprefsGUI
// #readme = scripts/autoexec/hideweapon.txt

package hideweapon {

function clientCmdSetWeaponsHudActive(%slot) {
	cancel($hideschedule);
	switch$($WeaponNames[%slot]) {
		case "Blaster":
			if (($hideweaponpref::blaster) && ($hideweaponpref::hideToggle)) {
				$pref::Player::renderMyItems = "1";
   				$hideschedule = schedule($hideweaponpref::hideweapondelay, 0, hidetehweapon);
   			}
		case "Plasma":
			if (($hideweaponpref::plasma) && ($hideweaponpref::hideToggle)) {
				$pref::Player::renderMyItems = "1";
   				$hideschedule = schedule($hideweaponpref::hideweapondelay, 0, hidetehweapon);
   			}
		case "Chaingun":
			if (($hideweaponpref::chain) && ($hideweaponpref::hideToggle)) {
				$pref::Player::renderMyItems = "1";
   				$hideschedule = schedule($hideweaponpref::hideweapondelay, 0, hidetehweapon);
   			}
		case "Disc":
			if (($hideweaponpref::disc) && ($hideweaponpref::hideToggle)) {
				$pref::Player::renderMyItems = "1";
   				$hideschedule = schedule($hideweaponpref::hideweapondelay, 0, hidetehweapon);
   			}
		case "GrenadeLauncher":
			if (($hideweaponpref::gl) && ($hideweaponpref::hideToggle)) {
				$pref::Player::renderMyItems = "1";
   				$hideschedule = schedule($hideweaponpref::hideweapondelay, 0, hidetehweapon);
   			}
		case "SniperRifle":
			if (($hideweaponpref::laser) && ($hideweaponpref::hideToggle)) {
				$pref::Player::renderMyItems = "1";
   				$hideschedule = schedule($hideweaponpref::hideweapondelay, 0, hidetehweapon);
   			}
		case "ELFGun":
			if (($hideweaponpref::elf) && ($hideweaponpref::hideToggle)) {
				$pref::Player::renderMyItems = "1";
   				$hideschedule = schedule($hideweaponpref::hideweapondelay, 0, hidetehweapon);
   			}
		case "Mortar":
			if (($hideweaponpref::mortar) && ($hideweaponpref::hideToggle)) {
				$pref::Player::renderMyItems = "1";
   				$hideschedule = schedule($hideweaponpref::hideweapondelay, 0, hidetehweapon);
   			}
		case "MissileLauncher":
			if (($hideweaponpref::missile) && ($hideweaponpref::hideToggle)) {
				$pref::Player::renderMyItems = "1";
   				$hideschedule = schedule($hideweaponpref::hideweapondelay, 0, hidetehweapon);
   			}
		case "ShockLance":
			if (($hideweaponpref::shocklance) && ($hideweaponpref::hideToggle)) {
				$pref::Player::renderMyItems = "1";
   				$hideschedule = schedule($hideweaponpref::hideweapondelay, 0, hidetehweapon);
   			}
		case "TargetingLaser":
			if (($hideweaponpref::tlaser) && ($hideweaponpref::hideToggle)) {
				$pref::Player::renderMyItems = "1";
   				$hideschedule = schedule($hideweaponpref::hideweapondelay, 0, hidetehweapon);
   			}
	}
	parent::clientCmdSetWeaponsHudActive(%slot);
	$pref::Player::renderMyItems = "1";
}

function clientCmdSetRepairReticle() {
	if (($hideweaponpref::repair) && ($hideweaponpref::hideToggle)) {
		cancel($hideschedule);
		$pref::Player::renderMyItems = "1";
		$hideschedule = schedule($hideweaponpref::hideweapondelay, 0, hidetehweapon);
	}
	parent::clientCmdSetRepairReticle();
}

function hidetehweapon() {
	$pref::Player::renderMyItems = "0";
}

function hideweaponToggle(%val) {
	if (%val) {
		if ($hideweaponprefs::hideToggle) {
			$hideweaponprefs::hideToggle = false;
			$tempHideToggle = true;
			$pref::Player::renderMyItems = "1";
		}
		else {
			$hideweaponprefs::hideToggle = true;
			$tempHideToggle = false;
			$pref::Player::renderMyItems = "0";
		}
	}
}

function tempHideWeaponToggle(%val) {
	if (%val) {
		if ($tempHideToggle) {
			$tempHideToggle = false;
			$pref::Player::renderMyItems = "1";
		}
		else {
			$tempHideToggle = true;
			$pref::Player::renderMyItems = "0";
		}
	}
}

function OptionsDlg::onWake( %this ) {
	if(!$hideWeaponToggleBinds) {
		$RemapName[$RemapCount]="Perm. hideweapon toggle";
		$RemapCmd[$RemapCount]="hideweaponToggle";
		$RemapCount++;
		$RemapName[$RemapCount]="Temp. hideweapon toggle";
		$RemapCmd[$RemapCount]="tempHideWeaponToggle";
		$RemapCount++;
		$hideWeaponToggleBinds = true;
	}
	parent::onWake(%this);
}

};

function hideweaponprefsSaveprefs() {
    export("$hideweaponpref::*", "prefs/hideweaponprefs.cs", false);
}

function hideweaponprefsStartup()
{
	if(!isfile("pref/hideweaponprefs.cs")) {
		hideweaponprefsSaveprefs();
    }
	exec("prefs/hideweaponprefs.cs");
}

new GuiControl(hideweaponprefsGUI) {
	profile = "GuiDialogProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "400 320";
	minExtent = "400 320";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";
	tabIndex = "0";
	guiSetup = "1";

	new ShellPaneCtrl() {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "102 67";
		extent = "400 320";
		minExtent = "400 320";
		visible = "1";
		text = "hideweapon Config";
		helpTag = "0";

		new ShellToggleButton(hideweaponBlaster) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "15 31";
			extent = "103 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$hideweaponpref::blaster";
			helpTag = "0";
			text = "Blaster";
			maxLength = "255";
		};

		new ShellToggleButton(hideweaponPlasma) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "15 56";
			extent = "103 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$hideweaponpref::plasma";
			helpTag = "0";
			text = "Plasma";
			maxLength = "255";
		};

		new ShellToggleButton(hideweaponChain) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "15 81";
			extent = "103 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$hideweaponpref::chain";
			helpTag = "0";
			text = "Chaingun";
			maxLength = "255";
		};

		new ShellToggleButton(hideweaponDisc) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "15 106";
			extent = "103 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$hideweaponpref::disc";
			helpTag = "0";
			text = "Disc";
			maxLength = "255";
		};

		new ShellToggleButton(hideweaponGL) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "15 131";
			extent = "103 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$hideweaponpref::gl";
			helpTag = "0";
			text = "GrenLauncher";
			maxLength = "255";
		};

		new ShellToggleButton(hideweaponMortar) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "15 156";
			extent = "103 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$hideweaponpref::mortar";
			helpTag = "0";
			text = "Mortar";
			maxLength = "255";
		};

		new ShellToggleButton(hideweaponLaser) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "15 181";
			extent = "103 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$hideweaponpref::laser";
			helpTag = "0";
			text = "Laser Rifle";
			maxLength = "255";
		};

		new ShellToggleButton(hideweaponELF) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "15 206";
			extent = "103 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$hideweaponpref::elf";
			helpTag = "0";
			text = "ELF Gun";
			maxLength = "255";
		};

		new ShellToggleButton(hideweaponShocklance) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "15 231";
			extent = "103 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$hideweaponpref::shocklance";
			helpTag = "0";
			text = "Shocklance";
			maxLength = "255";
		};

		new ShellToggleButton(hideweaponMissile) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "120 31";
			extent = "103 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$hideweaponpref::missile";
			helpTag = "0";
			text = "Missile Launcher";
			maxLength = "255";
		};

		new ShellToggleButton(hideweaponRepair) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "120 56";
			extent = "103 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$hideweaponpref::repair";
			helpTag = "0";
			text = "Repair Gun";
			maxLength = "255";
		};

		new ShellToggleButton(hideweaponTlaser) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "120 81";
			extent = "103 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$hideweaponpref::tlaser";
			helpTag = "0";
			text = "Targetting Laser";
			maxLength = "255";
		};

		new ShellToggleButton(hideweaponToggle) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "120 106";
			extent = "103 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$hideweaponpref::hideToggle";
			helpTag = "0";
			text = "Toggle";
			maxLength = "255";
		};

		new GuiTextCtrl(hideweaponDelayTextControl) {
                	profile = "ShellMediumTextProfile";
                	horizSizing = "right";
			vertSizing = "bottom";
    			position = "124 131";
			extent = "220 22";
    			minExtent = "8 8";
			visible = "1";
    			helpTag = "0";
			text = "hideweapon Delay (ms)";
    		};

		new ShellTextEditCtrl(hideweaponDelay) {
                	profile = "NewTextEditProfile";
                	horizSizing = "right";
                	vertSizing = "bottom";
                	position = "120 146";
    			extent = "220 22";
			minExtent = "10 10";
    			visible = "1";
                	variable = "$hideweaponpref::hideweapondelay";
    			helpTag = "0";
                	historySize = "0";
   			maxLength = "256";
			password = "0";
    			glowOffset = "0 0";
		};

		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "117 177";
			extent = "118 38";
			minExtent = "48 38";
			visible = "1";
			command = "hideweaponprefsSaveprefs();";
			helpTag = "0";
			text = "Save Prefs";
			simpleStyle = "0";
		};

	};
};

if(!isObject(hideweaponpref))
{
    new ScriptObject(hideweaponpref)
    {
        class = hideweaponpref;
    };
}

hideweaponprefsStartup();

activatePackage(hideweapon);

$hideWeaponToggleBinds = false;
$tempHideToggle = true;